OpenTTD Source: NWidgetContainer Class Reference

OpenTTD Source 14.0-beta3

Public Member Functions | Protected Attributes
NWidgetContainer Class Reference
Hierarchical widgets

Baseclass for container widgets. More...

`#include <widget_type.h>`

Inheritance diagram for NWidgetContainer:

## Public Member Functions
| NWidgetContainer (WidgetType tp)
void | AdjustPaddingForZoom () override
void | Add (std::unique_ptr< NWidgetBase > &&wid)
| Append widget wid to container. More...
void | FillWidgetLookup (WidgetLookup &widget_lookup) override
void | Draw (const Window *w) override
NWidgetCore * | GetWidgetFromPos (int x, int y) override
bool | IsEmpty ()
| Return whether the container is empty.
NWidgetBase * | GetWidgetOfType (WidgetType tp) override
| Retrieve a widget by its type. More...
Public Member Functions inherited from NWidgetBase
| NWidgetBase (WidgetType tp)
| Base class constructor. More...
virtual void | SetupSmallestSize (Window *w)=0
virtual void | AssignSizePosition (SizingType sizing, int x, int y, uint given_width, uint given_height, bool rtl)=0
template<class NWID >
NWID * | GetParentWidget ()
| Get parent widget of type NWID. More...
template<class NWID >
const NWID * | GetParentWidget () const
| Get parent widget of type NWID. More...
virtual bool | IsHighlighted () const
virtual TextColour | GetHighlightColour () const
virtual void | SetHighlighted ([[maybe_unused]] TextColour highlight_colour)
void | SetPadding (uint8_t top, uint8_t right, uint8_t bottom, uint8_t left)
| Set additional space (padding) around the widget. More...
void | SetPadding (const RectPadding &padding)
| Set additional space (padding) around the widget. More...
uint | GetHorizontalStepSize (SizingType sizing) const
| Get the horizontal sizing step. More...
uint | GetVerticalStepSize (SizingType sizing) const
| Get the vertical sizing step. More...
virtual void | SetDirty (const Window *w) const
| Mark the widget as 'dirty' (in need of repaint). More...
Rect | GetCurrentRect () const
Public Member Functions inherited from ZeroedMemoryAllocator
void * | operator new (size_t size)
| Memory allocator for a single class instance. More...
void * | operator new[] (size_t size)
| Memory allocator for an array of class instances. More...
void | operator delete (void *ptr)
| Memory release for a single class instance. More...
void | operator delete[] (void *ptr)
| Memory release for an array of class instances. More...

## Protected Attributes
std::vector< std::unique_ptr< NWidgetBase > > | children
| Child widgets in contaier.

## Additional Inherited Members
Data Fields inherited from NWidgetBase
WidgetType | type
| Type of the widget / nested widget.
uint | fill_x
| Horizontal fill stepsize (from initial size, `0` means not resizable).
uint | fill_y
| Vertical fill stepsize (from initial size, `0` means not resizable).
uint | resize_x
| Horizontal resize step (`0` means not resizable).
uint | resize_y
| Vertical resize step (`0` means not resizable).
uint | smallest_x
| Smallest horizontal size of the widget in a filled window.
uint | smallest_y
| Smallest vertical size of the widget in a filled window.
uint | current_x
| Current horizontal size (after resizing).
uint | current_y
| Current vertical size (after resizing).
int | pos_x
| Horizontal position of top-left corner of the widget in the window.
int | pos_y
| Vertical position of top-left corner of the widget in the window.
RectPadding | padding
| Padding added to the widget. Managed by parent container widget. (parent container may swap left and right for RTL)
RectPadding | uz_padding
| Unscaled padding, for resize calculation.
NWidgetBase * | parent
| Parent widget of this widget, automatically filled in when added to container.
Protected Member Functions inherited from NWidgetBase
void | StoreSizePosition (SizingType sizing, int x, int y, uint given_width, uint given_height)
| Store size and position. More...

## Detailed Description

Baseclass for container widgets.

Definition at line 445 of file widget_type.h.

## Member Function Documentation

## ◆ Add()

void NWidgetContainer::Add | ( | std::unique_ptr< NWidgetBase > && | wid | ) |

Append widget wid to container.

Parameters

  wid | Widget to append.

Definition at line 1161 of file widget.cpp.

References NWidgetBase::parent.

Referenced by MakeWidgetTree(), and MakeWindowNWidgetTree().

## ◆ Draw()

void NWidgetContainer::Draw | ( | const Window * | w | ) |
| overridevirtual

Draw the widgets of the tree. The function calls Window::DrawWidget for each widget with a non-negative index, after the widget itself is painted.

Parameters

  w | Window that owns the tree.

Implements NWidgetBase.

Reimplemented in NWidgetMatrix, and NWidgetStacked.

Definition at line 1175 of file widget.cpp.

Referenced by NWidgetToolbarContainer::Draw().

## ◆ FillWidgetLookup()

void NWidgetContainer::FillWidgetLookup | ( | WidgetLookup & | widget_lookup | ) |
| overridevirtual

Fill the Window::widget_lookup with pointers to nested widgets in the tree.

Parameters

  widget_lookup | The WidgetLookup.

Implements NWidgetBase.

Reimplemented in NWidgetMatrix, and NWidgetStacked.

Definition at line 1168 of file widget.cpp.

Referenced by NWidgetSocialPlugins::FillWidgetLookup(), NWidgetStacked::FillWidgetLookup(), and NWidgetMatrix::FillWidgetLookup().

## ◆ GetWidgetFromPos()

NWidgetCore * NWidgetContainer::GetWidgetFromPos | ( | int | x,
|  | int | y
| ) |  |
| overridevirtual

Retrieve a widget by its position.

Parameters

  x | Horizontal position relative to the left edge of the window.
  y | Vertical position relative to the top edge of the window.

Returns
  Returns the deepest nested widget that covers the given position, or `nullptr` if no widget can be found.

Implements NWidgetBase.

Reimplemented in NWidgetMatrix, and NWidgetStacked.

Definition at line 1184 of file widget.cpp.

## ◆ GetWidgetOfType()

NWidgetBase * NWidgetContainer::GetWidgetOfType | ( | WidgetType | tp | ) |
| overridevirtual

Retrieve a widget by its type.

Parameters

  tp | Widget type to search for.

Returns
  Returns the first widget of the specified type, or `nullptr` if no widget can be found.

Reimplemented from NWidgetBase.

Definition at line 1139 of file widget.cpp.

References children, NWidgetBase::GetWidgetOfType(), and NWidgetBase::type.

Referenced by MakeWindowNWidgetTree().

The documentation for this class was generated from the following files:

- src/widget_type.h
- src/widget.cpp